#include <unsupported/Eigen/CXX11/Tensor>
#include <iostream>

int main() {
  
  // Input regular
  Eigen::Tensor<float,1> in(2);

  // // Input mapped
  // vector<float> in_flt(2);
  // Eigen::TensorMap<Eigen::Tensor<float,1> > in(&in_flt[0], 2);

  // Set values
  in[0] = 1.f; in[1] = -2.f;

  // Output regular
  Eigen::Tensor<float,1> out(2);

  // // Output mapped
  // vector<float> out_flt(2);
  // Eigen::TensorMap<Eigen::Tensor<float,1> > out(&out_flt[0], 2);

  // // Define the CPU device
  // Eigen::DefaultDevice dev;

  // Define the GPU device
  Eigen::CudaStreamDevice stream;
  Eigen::GpuDevice dev(&stream);

  // Perform calculation
  out.device(dev) = in.tanh();

  std::cout << out << std::endl;

}
